import { CancellationToken, editor, languages, Position } from "monaco-editor-core";
import { IPaperclipEngineInfoProvider } from "./service/base";
export declare type Options = {
    getCurrentUri: () => string;
};
export declare class PaperclipMonacoServiceAdapter implements languages.DocumentColorProvider, languages.CompletionItemProvider {
    private _provider;
    private _options;
    constructor(_provider: IPaperclipEngineInfoProvider, _options: Options);
    provideDocumentColors(model: editor.IReadOnlyModel, token: CancellationToken): Promise<languages.IColorInformation[]>;
    provideColorPresentations(model: editor.IReadOnlyModel, info: languages.IColorInformation, token: CancellationToken): Promise<languages.IColorPresentation[]>;
    provideCompletionItems(model: editor.ITextModel, position: Position, context: languages.CompletionContext, token: CancellationToken): Promise<languages.CompletionList>;
}
