import { Node, ReferencePart } from "paperclip-utils";
export declare enum InferenceKind {
    Shape = 0,
    Array = 1,
    Any = 2
}
declare type BaseInference<TInferenceKind extends InferenceKind> = {
    kind: TInferenceKind;
};
export declare type ShapeInference = {
    fromSpread: boolean;
    properties: {
        [identifier: string]: ShapeProperty;
    };
} & BaseInference<InferenceKind.Shape>;
export declare type ShapeProperty = {
    optional?: boolean;
    value: Inference;
};
export declare type ArrayInference = {
    value: Inference;
} & BaseInference<InferenceKind.Array>;
export declare type AnyInference = BaseInference<InferenceKind.Any>;
export declare type Inference = ShapeInference | ArrayInference | AnyInference;
export declare type Context = {
    scope: {
        [identifier: string]: ReferencePart[];
    };
    inference: Inference;
};
export declare const infer: (ast: Node) => ShapeInference;
export {};
